#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "p2-support.h"


void initialize (struct DataBase *db)
{
    db->emp = (struct Employee*) malloc(sizeof(struct Employee)*dbSIZE);
    //allocate memory for 100 employees

    db->total = 0;
    //there are 0 employees at the beginning

    create_record("00003", "Wei", "Martin", "wm@vcu.edu", 98999.99, (date) { 1, 10, 2023 }, db);
    create_record("00007", "Mitch", "Martinez", "mitch@vcu.ed", 78999.88, (date) { 12, 15, 2022 }, db);
    create_record("00008", "David", "Boyle", "db@vcu.edu", 100000.01, (date) { 11, 10, 2022 }, db);
    create_record("00014", "Christine", "Bluer", "cb@vcu.edu", 40009.99, (date) { 12, 20, 2022 }, db);
    create_record("00105", "Stephen", "Black", "sb@vcu.edu", 8500.01, (date) { 1, 9, 2023 }, db);
    create_record("00001", "Chris", "Boyle", "cb@vcu.edu", 200000.01, (date) { 1, 8, 2023 }, db);
    create_record("00015", "Paula", "Brown", "pb@vcu.edu", 1000.37, (date) { 10, 25, 2022 }, db);
    create_record("00002", "Paul", "Green", "pg@vcu.edu", 2700.45, (date) { 8, 5, 2022 }, db);
    create_record("00006", "Chris", "Reddy", "cr@vcu.edu", 23040.67, (date) { 7, 8, 2022 }, db);
    create_record("00009", "Chris", "Magenta", "cj@vcu.edu", 23040.67, (date) { 1, 1, 2020 }, db);

}



void create_record(char ID[idSIZE], char first_name[nameSIZE], char last_name[nameSIZE], char email[emailSIZE],double salary, date hire_date, struct DataBase *db)
{
    strcpy(db->emp[db->total].ID, ID);
    strcpy(db->emp[db->total].first_name, first_name);
    strcpy(db->emp[db->total].last_name, last_name);
    strcpy(db->emp[db->total].email, email);
    db->emp[db->total].salary = salary;
    db->emp[db->total].hire_date = hire_date;
    db->total++;
}




void display_menu(struct DataBase *db) {
    int i;
    char id[idSIZE], last_name[nameSIZE];
    int exit_flag = 0;
    while (exit_flag == 0) {
        printf("**************************************************************\n");
        printf("********** Employee Database - Total Employees: %03d **********\n", db->total);
        printf("**************************************************************\n\n");

        printf("Choose one of the menu options below:\n");
        printf("1. Sort by ID\n");
        printf("2. Sort by hire date\n");
        printf("3. Display all employees\n");
        printf("4. Search employees by ID\n");
        printf("5. Search employees by last name\n");
        printf("6. Delete employee by ID\n");
        printf("7. Save\n");
        printf("8. Exit\n");

        if (scanf("%d", &i) <= 0) {
            printf("Enter only an integer\n");
            exit(0);
        } else {
            switch (i) {
                case 1:
                    sortById(db);
                    printf("\n");
                    break;
                case 2:
                    sortByHireDate(db);
                    break;
                case 3:
                    displayAllEmployees(db);
                    break;
                case 4:
                    printf("Enter the ID of the employee you want to search for: ");
                    scanf("%s", id);
                    searchEmployeesById(db, id);
                    break;
                case 5:
                    printf("Enter the last name of the employee you want to search for: ");
                    scanf("%s", last_name);
                    searchEmployeeByLastName(db, last_name);
                    break;
                case 6:
                    printf("Enter the ID of the employee you want to delete: ");
                    scanf("%s", id);
                    deleteEmployeeById(db, id);
                    break;
                case 7:
                    save(db);
                    printf("The database has been saved successfully!\n");
                    break;
                case 8:
                    printf("Exiting the program...\n");
                    quit(db);
                    break;
                default:
                    printf("Invalid option selected. Please try again.\n");
                    break;
            }
        }
    }
}

int compareFunction(const void *a, const void *b) {
    return strcmp(((struct Employee *) a)->ID, ((struct Employee *) b)->ID);
}

int compareFunction2(const void *a, const void *b) {
    struct Employee *ea = (struct Employee *) a;
    struct Employee *eb = (struct Employee *) b;
    if (ea->hire_date.year == eb->hire_date.year) {
        if (ea->hire_date.month == eb->hire_date.month) {
            return ea->hire_date.day - eb->hire_date.day;
        } else {
            return ea->hire_date.month - eb->hire_date.month;
        }
    } else {
        return ea->hire_date.year - eb->hire_date.year;
    }
}
void sortById(struct DataBase *db) {
    qsort(db->emp, db->total, sizeof(struct Employee), compareFunction);
}

void sortByHireDate(struct DataBase *db) {
    qsort(db->emp, db->total, sizeof(struct Employee), compareFunction2);
}
void print_title()
{
    printf("No. ID    Name          Email        Salary      Hire Date\n");
    printf("--- ----- ------------- ------------ ----------- --/--/----\n");
}
char* makeFullName(char *first, char *last, char *temp)
{
    strncpy(temp, first, 20);
    strcat(temp, " ");
    strcat(temp, last);
    return temp;
}
char* truncateName(char fullName[]) {
    int len = strlen(fullName);
    if (len > 13) {
        fullName[13] = '\0';
    }
    return fullName;
}
void displayAllEmployees(struct DataBase *db) {
    print_title();
    for (int i = 0; i < db->total; i++) {
        char temp[20];
        printf("%-3d ", i);
        printf("%-5s ", db->emp[i].ID);
        printf("%-13s ", truncateName(makeFullName(db->emp[i].first_name,db->emp[i].last_name,temp)));
        printf("%-12s ", db->emp[i].email);
        printf("$%10.2f ", db->emp[i].salary);
        printf("%02d/", db->emp[i].hire_date.month);
        printf("%02d/", db->emp[i].hire_date.day);
        printf("%4d ", db->emp[i].hire_date.year);
        printf("\n");
    }
}


void searchEmployeesById(DataBase *db, char *id) {
    int i;
    int count = 0;

    for (i = 0; i < db->total; i++) {
        if (strcmp(db->emp[i].ID, id) == 0) {
            char temp[20];
            printf("%-3d ", i);
            printf("%-5s ", db->emp[i].ID);
            printf("%-13s ", truncateName(makeFullName(db->emp[i].first_name,db->emp[i].last_name,temp)));
            printf("%-12s ", db->emp[i].email);
            printf("$%10.2f ", db->emp[i].salary);
            printf("%02d/", db->emp[i].hire_date.month);
            printf("%02d/", db->emp[i].hire_date.day);
            printf("%4d ", db->emp[i].hire_date.year);
            printf("\n");
            count++;
        }
    }

    if (count == 0) {
        printf("Employee with ID %s not found\n", id);
    }
}

void searchEmployeeByLastName(DataBase* db, char* last_name) {
    int found = 0;
    for (int i = 0; i < db->total; i++) {
        if (strcmp(db->emp[i].last_name, last_name) == 0) {
            found = 1;
            char temp[20];
            printf("%-3d ", i);
            printf("%-5s ", db->emp[i].ID);
            printf("%-13s ", truncateName(makeFullName(db->emp[i].first_name,db->emp[i].last_name,temp)));
            printf("%-12s ", db->emp[i].email);
            printf("$%10.2f ", db->emp[i].salary);
            printf("%02d/", db->emp[i].hire_date.month);
            printf("%02d/", db->emp[i].hire_date.day);
            printf("%4d ", db->emp[i].hire_date.year);
            printf("\n");
        }
    }
    if (!found) {
        printf("No employees found with the last name '%s'\n", last_name);
    }
}
void deleteEmployeeById(DataBase *db, char id[]) {
    int i, j;
    for(i=0; i<db->total; i++) {
        if(strcmp(db->emp[i].ID, id) == 0) {
            free(db->emp);
            for(j=i+1; j<db->total; j++) {
                db->emp[j-1] = db->emp[j];
            }
            db->total--;
            printf("\nEmployee with ID %s deleted successfully.\n", id);
            return;
        }
    }
    printf("\nEmployee with ID %s not found in the database.\n", id);
}
void save(struct DataBase *db)
{
    FILE *dbfu;
    dbfu = fopen("database_updated.txt", "w");
    if (dbfu == NULL) {
        printf("File cannot be created");
        return;
    }
    for (int i = 0; i < db->total; i++) {
        fprintf(dbfu, "%-5s %-13s %-13s %-12s $%10.2f %02d/%02d/%04d\n",
                db->emp[i].ID, db->emp[i].first_name, db->emp[i].last_name,
                db->emp[i].email, db->emp[i].salary, db->emp[i].hire_date.month,
                db->emp[i].hire_date.day, db->emp[i].hire_date.year);
    }
    fclose(dbfu);//close file after writing
    printf("Database saved successfully!\n");
}
void quit(struct DataBase *db)
{
    int i;
    for (i=0; i < db->total; i++)
    {
        free(db->emp);
        db->emp = NULL;
    }

    free(db->emp);
    free(db);
    db = NULL;
}
int main ()
{
    struct DataBase* db;
    db = malloc(sizeof(struct DataBase));
    initialize (db);
    display_menu (db);
    free(db);
    return 0;
}





